#include "KeyboardEx.h"

// Librairie HIDRemote.h de drdnar
// https://github.com/drdnar/Arduino-HID-Remote

#include "HIDRemote.h"

// Constante pour les médias
//HID_MEDIA_MUTE
//HID_MEDIA_VOLUME_UP
//HID_MEDIA_VOLUME_DOWN
//HID_MEDIA_PLAY_PAUSE
//HID_MEDIA_STOP
//HID_MEDIA_PREVIOUS

//HID_MEDIA_NEXT

// Constante pour le mail
//HID_MEDIA_MAIL

// Constante pour la calculatrice
//HID_MEDIA_CALCULATOR

// Constante pour le navigateur internet
//HID_WWW_SEARCH
//HID_WWW_HOME
//HID_WWW_FAVORITES
//HID_WWW_REFRESH
//HID_WWW_STOP
//HID_WWW_FORWARD
//HID_WWW_BACK

void setup() {
  KeyboardEx.begin();
  Media.begin();
  // KeyboardEx.setOS(Windows);
  Serial.begin(115200);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB
  }
  delay(6000);
}

void loop() {

  // **************************************************************************************
  //  Test de la fonction Media.execute(...)  <HID Consumer>
  //  et de la fonction getStatusLeds(...)
  // **************************************************************************************
  KeyboardEx.println(F("*** Test de la fonction HIDRemote.execute(...)  <HID Consumer> ***"));
  KeyboardEx.println(F("*** et de la fonction getStatusLeds(...) ***"));

  KeyboardEx.println();

  KeyboardEx.print("Etat de la Led CAPS LOCK: ");
  KeyboardEx.println(KeyboardEx.getStatusLeds(LED_CAPS_LOCK));
  KeyboardEx.println();

  KeyboardEx.print("Etat de la Led NUM LOCK: ");
  KeyboardEx.println(KeyboardEx.getStatusLeds(LED_NUM_LOCK));
  
  Media.execute(HID_MEDIA_CALCULATOR); // lance la calculatrice
  Media.execute(HID_MEDIA_MAIL);       // lance l'application mail

  for (byte i = 0; i < 10; i++) {
    Media.execute(HID_MEDIA_VOLUME_UP); // augmente le volume d'une unité, 9 fois de suite
    delay(500);
  }

  Media.execute(HID_WWW_HOME);         // lance le navigateur Web

  Media.end();
  KeyboardEx.end();
  while (1);
}
