// Code original de drdnar
// https://github.com/drdnar/Arduino-HID-Remote

#ifndef HID_REMOTE_H
#define HID_REMOTE_H

#include "HIDEX.h"

#define REMOTE_REPORT_LENGTH 2

#define HID_MEDIA_MUTE         (1 << 0)
#define HID_MEDIA_VOLUME_UP    (1 << 1)
#define HID_MEDIA_VOLUME_DOWN  (1 << 2)
#define HID_MEDIA_PLAY_PAUSE   (1 << 3)
#define HID_MEDIA_STOP         (1 << 4)
#define HID_MEDIA_PREVIOUS     (1 << 5)
#define HID_MEDIA_NEXT         (1 << 6)

#define HID_MEDIA_MAIL         (1 << 7)
#define HID_MEDIA_CALCULATOR   (1 << 8)

#define HID_WWW_SEARCH       (1 << 9)
#define HID_WWW_HOME         (1 << 10)
#define HID_WWW_FAVORITES    (1 << 11)
#define HID_WWW_REFRESH      (1 << 12)
#define HID_WWW_STOP         (1 << 13)
#define HID_WWW_FORWARD      (1 << 14)
#define HID_WWW_BACK         (1 << 15)
typedef struct {
    uint8_t keys[REMOTE_REPORT_LENGTH];
} RemoteReport;

class HIDRemote_
{
private:
    RemoteReport report;
    void sendReport(RemoteReport* report);
    void sendReport(void);
    void press(uint16_t key);
    void release(uint16_t key);
    // Send an empty report to prevent repeated actions
    void releaseAll(void);
    
public:
  HIDRemote_(void);
    void begin(void);
    void end(void);
    void execute(uint16_t key);
};

extern HIDRemote_ Media;

#endif // HID_REMOTE_H
